%define expat_version           1.95.5
%define glib2_version           2.6.0
%define dbus_version            0.90
%define dbus_glib_version       0.70
%define dbus_python_version     0.70
%define pygtk2                  2.0.0
%define gnome_python2           2.0.0
%define udev_version            145
%define util_linux_version      2.12a-16
%define initscripts_version     8.04-1
%define kernel_version          2.6.17
%define gettext_version         0.14.1-14
%define libusb_version          0.1.10a-1
%define pciutils_version        2.2.1
%define dmidecode_version       2.7
%define cryptsetup_luks_version 1.0.1-2
%define pm_utils_version        0.10-1
%define gtk_doc_version         1.4
%define consolekit_version      0.2.0
%define acl_version             2.2.39
%define gperf_version           3.0.1

%define hal_user_uid            68

Summary: Hardware Abstraction Layer
Name: hal
Version: 0.5.14
Release: 11%{?dist}
URL: http://www.freedesktop.org/Software/hal
Source0: http://hal.freedesktop.org/releases/%{name}-%{version}.tar.bz2

# OLPC specific, not upstream as is a hack until OFW lands
Source1: 05-olpc-detect.fdi

# Change priority in the init sequence so that HAL loads before any of
# the virt tools.
Patch2: hal-change-priority.patch

# We don't ship dellWirelessCtl -- remove it.
# https://bugzilla.redhat.com/show_bug.cgi?id=488177
Patch4: hal-remove-dell-killswitch.patch

# Identify American Megatrends Inc. Virtual Keyboard and Mouse as an
# evdev device.
# http://lists.freedesktop.org/archives/hal/2009-March/013125.html
Patch9: hal-KVM-evdev.patch

# ThinkPad HDAPS accelerometer is not an input device.
# http://bugs.freedesktop.org/show_bug.cgi?id=22442
Patch11: hal-HDAPS-blacklist.patch

# Un-ignore absolute axes for the Xen Virtual Pointer
# Not required upstream anymore.
# https://bugzilla.redhat.com/show_bug.cgi?id=523914
Patch13: hal-xen-unignore-axes.patch

# Bump HAL_PATH_MAX to 4096 to match upstream.
# Already committed upstream, a2c3dd5a04d79265772c09c4280606d5c2ed72c6
Patch14: hal-0.5.14-use-correct-path-length.patch

# Don't use error prio init and segfault the prober.
# Already committed upstream, dcb2829b8eff61463b0869614ddb07b1c86cecaa
Patch15: hal-0.5.15-no-segfault-probe-input.patch

# Make the initscript LSB compliant. Part of a RHEL initiative.
# Already committed upstream, 18a43206d2f3c1664d853566b2a264dc756ada7e
Patch16: hal-0.5.15-make-initscript-lsb-compliant.patch

# With new dm-udev rules (included since device-mapper 1.02.39) there
# is DM_UDEV_DISABLE_OTHER_RULES_FLAG variable which controls that scan
# should be ignored for this device (it is set for all internal devices,
# including temporary cryptsetup, internal parts of lvm devices etc.)
# See http://article.gmane.org/gmane.linux.hotplug.devel/15936
Patch17: hal-0.5.15-ignore-device-requested-by-DM-udev-rules.patch

# Forward port from RHEL5 to remove the ugly error when using an invalid UDI
Patch29: hal-0.5.8.1-udi-not-exist-get-property.patch

# Forward port from RHEL5 to get some configuration values from sysconfig.
Patch40: hal-0.5.8.1-get-args-from-sysconfig.patch

# Only allow users at the local console to manipulate devices.
# Not required upstream anymore, as we're using ConsoleKit.
Patch100: hal-use-at-console.patch

License: AFL or GPLv2
Group: System Environment/Libraries
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n) 
Requires(post): chkconfig
Requires(preun): chkconfig
Requires(post): /sbin/ldconfig
Requires(pre): /usr/sbin/useradd
Requires(postun): gawk, grep, coreutils, /sbin/ldconfig
BuildRequires: expat-devel >= %{expat_version}
BuildRequires: glib2-devel >= %{glib2_version}
BuildRequires: dbus-devel  >= %{dbus_version}
BuildRequires: dbus-glib-devel >= %{dbus_glib_version}
BuildRequires: python-devel
BuildRequires: hwdata
BuildRequires: gettext >= %{gettext_version}
BuildRequires: dbus-glib >= %{dbus_glib_version}
BuildRequires: perl(XML::Parser)
BuildRequires: gtk-doc >= %{gtk_doc_version}
BuildRequires: libblkid-devel
BuildRequires: pciutils-devel >= %{pciutils_version}
BuildRequires: xmlto
BuildRequires: gperf >= %{gperf_version}

%ifnarch s390 s390x
BuildRequires: libusb-devel >= %{libusb_version}
%endif
Requires: dbus >= %{dbus_version}
Requires: dbus-glib >= %{dbus_glib_version}
Requires: glib2 >= %{glib2_version}
Requires: udev >= %{udev_version} 
Requires: util-linux >= %{util_linux_version} 
Requires: initscripts >= %{initscripts_version}
Requires: cryptsetup-luks >= %{cryptsetup_luks_version}
%ifnarch s390 s390x
Requires: pm-utils >= %{pm_utils_version}
%endif 
Conflicts: kernel < %{kernel_version}
%ifnarch s390 s390x
Requires: libusb >= %{libusb_version}
%endif
%ifarch %{ix86} x86_64
Requires: dmidecode >= %{dmidecode_version}
%endif
Requires: ConsoleKit >= %{consolekit_version}
Requires: acl >= %{acl_version}
Requires: hal-libs = %{version}-%{release}
Requires: hal-info
Obsoletes: %{name} < 0.5.9-1
Obsoletes: %{name}-gnome

BuildRequires: autoconf, automake, libtool

%description
HAL is a daemon for collecting and maintaining information from several
sources about the hardware on the system.

%package libs
Summary: Libraries for accessing HAL
Group: Development/Libraries
Requires: dbus >= %{dbus_version}
Obsoletes: %{name} < 0.5.9-1

%description libs
Libraries for accessing HAL.

%package devel
Summary: Libraries and headers for HAL
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: dbus-devel >= %{dbus_version}
Requires: pkgconfig

%description devel
Headers and libraries for HAL.

%package docs
Summary: Documentation for HAL
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description docs
API docs for HAL.

%package storage-addon
Summary: Storage polling support for HAL
Group: System Environment/Libraries
Requires: %{name} = %{version}-%{release}

%description storage-addon
Storage polling support for HAL

%prep
%setup -q -n %{name}-%{version}
%patch2 -p1 -b .priority
%patch4 -p1 -b .dell-killswitch
%patch9 -p1 -b .kvm-evdev
%patch11 -p1 -b .hdaps-blacklist
%patch13 -p1 -b .xen-unignore
%patch14 -p1 -b .use-correct-path-len
%patch15 -p1 -b .no-segfault-probe-input
%patch16 -p1 -b .initscript-lsb
%patch17 -p1 -b .ignore-device
%patch29 -p1 -b .udi-not-exist
%patch40 -p1 -b .get-args-from-sysconfig.patch
%patch100 -p1 -b .drop-polkit

autoreconf -i -f

%build
%configure					\
    --enable-docbook-docs			\
    --docdir=%{_docdir}/%{name}-%{version}	\
    --with-os-type=redhat			\
    --with-udev-prefix=/etc			\
    --disable-console-kit			\
    --disable-policy-kit			\
    --disable-acpi-ibm				\
    --disable-smbios				\
    --enable-umount-helper			\
    --without-usb-csr				\
    --without-cpufreq				\
    --with-eject=%{_sbindir}/eject

sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool

make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

# deprecated keys
cp -p fdi/information/10freedesktop/01-deprecated-keys.fdi $RPM_BUILD_ROOT%{_datadir}/hal/fdi/information/10freedesktop/

cp README AUTHORS NEWS COPYING HACKING $RPM_BUILD_ROOT%{_datadir}/doc/%{name}-%{version}

rm -f $RPM_BUILD_ROOT%{_libdir}/*.la
rm -f $RPM_BUILD_ROOT%{_libdir}/*.a

# So that this can be %ghost-ed
touch $RPM_BUILD_ROOT%{_localstatedir}/run/hald/acl-list

%clean
rm -rf $RPM_BUILD_ROOT

%pre
# Add the "haldaemon" user and group
getent group haldaemon >/dev/null || groupadd -g %{hal_user_uid} -r haldaemon
getent passwd haldaemon >/dev/null || \
	useradd -r -u %{hal_user_uid} -g haldaemon -G haldaemon -d '/' -s /sbin/nologin \
	-c "HAL daemon" haldaemon

%post
/sbin/ldconfig
/sbin/chkconfig --add haldaemon

%preun
if [ $1 = 0 ]; then
    service haldaemon stop > /dev/null 2>&1
    /sbin/chkconfig --del haldaemon
fi

%postun
/sbin/ldconfig
#if [ "$1" -ge "1" ]; then
#  service haldaemon condrestart > /dev/null 2>&1
#fi

%triggerpostun -- hal < 0.5.7-3
#remove lingering fstab-sync entries from /etc/fstab
/bin/cp -f /etc/fstab /etc/fstab.hal-save
(IFS="
"; while read line; do echo $line | awk '{print $4}' | grep -q managed || echo $line | grep -q "^#.*fstab-sync" || echo $line; done < /etc/fstab > fstab.replace)

if [ -s fstab.replace ]; then
  /bin/cp -f fstab.replace /etc/fstab
fi

%triggerpostun -- hal < 0.5.11-0.1.rc1
if [ "$1" -ge "1" ]; then
  mv -uf %{_localstatedir}/lib/hal/acl-list %{_localstatedir}/run/hald 2>/dev/null || :
  rm -rf %{_localstatedir}/lib/hal
fi

%files
%defattr(-,root,root,-)

%doc %dir %{_datadir}/doc/%{name}-%{version}
%doc %{_datadir}/doc/%{name}-%{version}/NEWS
%doc %{_datadir}/doc/%{name}-%{version}/COPYING
%doc %{_datadir}/doc/%{name}-%{version}/AUTHORS
%doc %{_datadir}/doc/%{name}-%{version}/HACKING
%doc %{_datadir}/doc/%{name}-%{version}/README

%config %{_sysconfdir}/dbus-1/system.d/hal.conf

%config %{_sysconfdir}/rc.d/init.d/haldaemon

%dir %{_sysconfdir}/hal
%{_sysconfdir}/hal/*

/sbin/umount.hal
%{_sbindir}/hald
%{_bindir}/*

%{_libexecdir}/*
%exclude %{_libexecdir}/hald-addon-storage

%dir %{_datadir}/hal
%dir %{_datadir}/hal/fdi
%{_datadir}/hal/fdi/*

%dir %{_libexecdir}/scripts
%{_libexecdir}/scripts/*
%{_mandir}/man1/*
%{_mandir}/man8/*

/etc/udev/rules.d/90-hal.rules

%attr(0700,haldaemon,haldaemon) %dir %{_localstatedir}/cache/hald
%attr(0700,haldaemon,haldaemon) %dir %{_localstatedir}/run/hald
%ghost %{_localstatedir}/run/hald/acl-list

%files libs
%defattr(-,root,root,-)
%{_libdir}/*hal*.so.*

%files devel
%defattr(-,root,root,-)

%{_libdir}/lib*.so
%{_libdir}/pkgconfig/*
%{_includedir}/*

%files docs
%defattr(-,root,root,-)

%doc %dir %{_datadir}/doc/%{name}-%{version}/spec
%doc %{_datadir}/doc/%{name}-%{version}/spec/*

%dir %{_datadir}/gtk-doc/html/libhal
%{_datadir}/gtk-doc/html/libhal/*

%dir %{_datadir}/gtk-doc/html/libhal-storage
%{_datadir}/gtk-doc/html/libhal-storage/*

%files storage-addon
%defattr(-,root,root,-)
%{_libexecdir}/hald-addon-storage


%changelog

